

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>Document Revision History &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1"><a class="reference internal" href="../LanguageGuide/TheBasics.html">Language Guide</a></li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="RevisionHistory.html">Revision History</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="RevisionHistory.html#">Document Revision History</a></li>
</ul>
</li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="RevisionHistory.html#">Document Revision History</a></li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="document-revision-history">
<h1>Document Revision History<a class="headerlink" href="RevisionHistory.html#document-revision-history" title="Permalink to this headline"></a></h1>
<p><strong>2018-06-04</strong></p>
<ul class="simple">
<li>Updated for Swift 4.2.</li>
<li>Added information about accessing all of an enumeration’s cases to the <a class="reference internal" href="../LanguageGuide/Enumerations.html#ID581"><span class="std std-ref">Iterating over Enumeration Cases</span></a> section.</li>
<li>Added information about <code class="docutils literal"><span class="pre">#error</span></code> and <code class="docutils literal"><span class="pre">#warning</span></code> to the <a class="reference internal" href="../ReferenceManual/Statements.html#ID582"><span class="std std-ref">Compile-Time Diagnostic Statement</span></a> section.</li>
<li>Added information about inlining to the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section under the <code class="docutils literal"><span class="pre">inlinable</span></code> and <code class="docutils literal"><span class="pre">usableFromInline</span></code> attributes.</li>
<li>Added information about members that are looked up by name at runtime to the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section under the <code class="docutils literal"><span class="pre">dynamicMemberLookup</span></code> attribute.</li>
</ul>
<p><strong>2018-03-29</strong></p>
<ul class="simple">
<li>Updated for Swift 4.1.</li>
<li>Added information about synthesized implementations of equivalence operators to the <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID45"><span class="std std-ref">Equivalence Operators</span></a> section.</li>
<li>Added information about conditional protocol conformance to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID378"><span class="std std-ref">Extension Declaration</span></a> section of the <a class="reference internal" href="../ReferenceManual/Declarations.html"><span class="doc">Declarations</span></a> chapter, and to the <a class="reference internal" href="../LanguageGuide/Protocols.html#ID574"><span class="std std-ref">Conditionally Conforming to a Protocol</span></a> section of the <a class="reference internal" href="../LanguageGuide/Protocols.html"><span class="doc">Protocols</span></a> chapter.</li>
<li>Added information about recursive protocol constraints to the <a class="reference internal" href="../LanguageGuide/Generics.html#ID575"><span class="std std-ref">Using a Protocol in Its Associated Type’s Constraints</span></a> section.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">canImport()</span></code> and <code class="docutils literal"><span class="pre">targetEnvironment()</span></code> platform conditions to <a class="reference internal" href="../ReferenceManual/Statements.html#ID539"><span class="std std-ref">Conditional Compilation Block</span></a>.</li>
</ul>
<p><strong>2017-12-04</strong></p>
<ul class="simple">
<li>Updated for Swift 4.0.3.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID563"><span class="std std-ref">Key-Path Expression</span></a> section, now that key paths support subscript components.</li>
</ul>
<p><strong>2017-09-19</strong></p>
<ul class="simple">
<li>Updated for Swift 4.0.</li>
<li>Added information about exclusive access to memory to the <a class="reference internal" href="../LanguageGuide/MemorySafety.html"><span class="doc">Memory Safety</span></a> chapter.</li>
<li>Added the <a class="reference internal" href="../LanguageGuide/Generics.html#ID557"><span class="std std-ref">Associated Types with a Generic Where Clause</span></a> section, now that you can use generic <code class="docutils literal"><span class="pre">where</span></code> clauses to constrain associated types.</li>
<li>Added information about multiline string literals to the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID286"><span class="std std-ref">String Literals</span></a> section of the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html"><span class="doc">Strings and Characters</span></a> chapter, and to the <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID417"><span class="std std-ref">String Literals</span></a> section of the <a class="reference internal" href="../ReferenceManual/LexicalStructure.html"><span class="doc">Lexical Structure</span></a> chapter.</li>
<li>Updated the discussion of the <code class="docutils literal"><span class="pre">objc</span></code> attribute in <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a>, now that this attribute is inferred in fewer places.</li>
<li>Added the <a class="reference internal" href="../LanguageGuide/Generics.html#ID558"><span class="std std-ref">Generic Subscripts</span></a> section, now that subscripts can be generic.</li>
<li>Updated the discussion in the <a class="reference internal" href="../LanguageGuide/Protocols.html#ID282"><span class="std std-ref">Protocol Composition</span></a> section of the <a class="reference internal" href="../LanguageGuide/Protocols.html"><span class="doc">Protocols</span></a> chapter, and in the <a class="reference internal" href="../ReferenceManual/Types.html#ID454"><span class="std std-ref">Protocol Composition Type</span></a> section of the <a class="reference internal" href="../ReferenceManual/Types.html"><span class="doc">Types</span></a> chapter, now that protocol composition types can contain a superclass requirement.</li>
<li>Updated the discussion of protocol extensions in <a class="reference internal" href="../ReferenceManual/Declarations.html#ID378"><span class="std std-ref">Extension Declaration</span></a> now that <code class="docutils literal"><span class="pre">final</span></code> isn’t allowed in them.</li>
<li>Added information about preconditions and fatal errors to the <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID335"><span class="std std-ref">Assertions and Preconditions</span></a> section.</li>
</ul>
<p><strong>2017-03-27</strong></p>
<ul class="simple">
<li>Updated for Swift 3.1.</li>
<li>Added the <a class="reference internal" href="../LanguageGuide/Generics.html#ID553"><span class="std std-ref">Extensions with a Generic Where Clause</span></a> section with information about extensions that include requirements.</li>
<li>Added examples of iterating over a range to the <a class="reference internal" href="../LanguageGuide/ControlFlow.html#ID121"><span class="std std-ref">For-In Loops</span></a> section.</li>
<li>Added an example of failable numeric conversions to the <a class="reference internal" href="../LanguageGuide/Initialization.html#ID224"><span class="std std-ref">Failable Initializers</span></a> section.</li>
<li>Added information to the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section about using the <code class="docutils literal"><span class="pre">available</span></code> attribute with a Swift language version.</li>
<li>Updated the discussion in the <a class="reference internal" href="../ReferenceManual/Types.html#ID449"><span class="std std-ref">Function Type</span></a> section to note that argument labels are not allowed when writing a function type.</li>
<li>Updated the discussion of Swift language version numbers in the <a class="reference internal" href="../ReferenceManual/Statements.html#ID539"><span class="std std-ref">Conditional Compilation Block</span></a> section, now that an optional patch number is allowed.</li>
<li>Updated the discussion in the <a class="reference internal" href="../ReferenceManual/Types.html#ID449"><span class="std std-ref">Function Type</span></a> section, now that Swift distinguishes between functions that take multiple parameters and functions that take a single parameter of a tuple type.</li>
<li>Removed the Dynamic Type Expression section from the <a class="reference internal" href="../ReferenceManual/Expressions.html"><span class="doc">Expressions</span></a> chapter, now that <code class="docutils literal"><span class="pre">type(of:)</span></code> is a Swift standard library function.</li>
</ul>
<p><strong>2016-10-27</strong></p>
<ul class="simple">
<li>Updated for Swift 3.0.1.</li>
<li>Updated the discussion of weak and unowned references in the <a class="reference internal" href="../LanguageGuide/AutomaticReferenceCounting.html"><span class="doc">Automatic Reference Counting</span></a> chapter.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">unowned</span></code>, <code class="docutils literal"><span class="pre">unowned(safe)</span></code>, and <code class="docutils literal"><span class="pre">unowned(unsafe)</span></code> declaration modifiers in the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID381"><span class="std std-ref">Declaration Modifiers</span></a> section.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/TypeCasting.html#ID342"><span class="std std-ref">Type Casting for Any and AnyObject</span></a> section about using an optional value when a value of type <code class="docutils literal"><span class="pre">Any</span></code> is expected.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Expressions.html"><span class="doc">Expressions</span></a> chapter to separate the discussion of parenthesized expressions and tuple expressions.</li>
</ul>
<p><strong>2016-09-13</strong></p>
<ul class="simple">
<li>Updated for Swift 3.0.</li>
<li>Updated the discussion of functions in the <a class="reference internal" href="../LanguageGuide/Functions.html"><span class="doc">Functions</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID362"><span class="std std-ref">Function Declaration</span></a> section to note that all parameters get an argument label by default.</li>
<li>Updated the discussion of operators in the <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html"><span class="doc">Advanced Operators</span></a> chapter, now that you implement them as type methods instead of as global functions.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">open</span></code> and <code class="docutils literal"><span class="pre">fileprivate</span></code> access-level modifiers to the <a class="reference internal" href="../LanguageGuide/AccessControl.html"><span class="doc">Access Control</span></a> chapter.</li>
<li>Updated the discussion of <code class="docutils literal"><span class="pre">inout</span></code> in the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID362"><span class="std std-ref">Function Declaration</span></a> section to note that it appears in front of a parameter’s type instead of in front of a parameter’s name.</li>
<li>Updated the discussion of the <code class="docutils literal"><span class="pre">&#64;noescape</span></code> and <code class="docutils literal"><span class="pre">&#64;autoclosure</span></code> attributes in the <a class="reference internal" href="../LanguageGuide/Closures.html#ID546"><span class="std std-ref">Escaping Closures</span></a> and <a class="reference internal" href="../LanguageGuide/Closures.html#ID543"><span class="std std-ref">Autoclosures</span></a> sections and the <a class="reference internal" href="../ReferenceManual/Attributes.html"><span class="doc">Attributes</span></a> chapter now that they are type attributes, rather than declaration attributes.</li>
<li>Added information about operator precedence groups to the <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID47"><span class="std std-ref">Precedence for Custom Infix Operators</span></a> section of the <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html"><span class="doc">Advanced Operators</span></a> chapter, and to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID550"><span class="std std-ref">Precedence Group Declaration</span></a> section of the <a class="reference internal" href="../ReferenceManual/Declarations.html"><span class="doc">Declarations</span></a> chapter.</li>
<li>Updated discussion throughout to use macOS instead of OS X, <code class="docutils literal"><span class="pre">Error</span></code> instead of <code class="docutils literal"><span class="pre">ErrorProtocol</span></code>, and protocol names such as <code class="docutils literal"><span class="pre">ExpressibleByStringLiteral</span></code> instead of <code class="docutils literal"><span class="pre">StringLiteralConvertible</span></code>.</li>
<li>Updated the discussion in the <a class="reference internal" href="../LanguageGuide/Generics.html#ID192"><span class="std std-ref">Generic Where Clauses</span></a> section of the <a class="reference internal" href="../LanguageGuide/Generics.html"><span class="doc">Generics</span></a> chapter and in the <a class="reference internal" href="../ReferenceManual/GenericParametersAndArguments.html"><span class="doc">Generic Parameters and Arguments</span></a> chapter, now that generic <code class="docutils literal"><span class="pre">where</span></code> clauses are written at the end of a declaration.</li>
<li>Updated the discussion in the <a class="reference internal" href="../LanguageGuide/Closures.html#ID546"><span class="std std-ref">Escaping Closures</span></a> section, now that closures are nonescaping by default.</li>
<li>Updated the discussion in the <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID333"><span class="std std-ref">Optional Binding</span></a> section of the <a class="reference internal" href="../LanguageGuide/TheBasics.html"><span class="doc">The Basics</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Statements.html#ID432"><span class="std std-ref">While Statement</span></a> section of the <a class="reference internal" href="../ReferenceManual/Statements.html"><span class="doc">Statements</span></a> chapter, now that <code class="docutils literal"><span class="pre">if</span></code>, <code class="docutils literal"><span class="pre">while</span></code>, and <code class="docutils literal"><span class="pre">guard</span></code> statements use a comma-separated list of conditions without <code class="docutils literal"><span class="pre">where</span></code> clauses.</li>
<li>Added information about switch cases that have multiple patterns to the <a class="reference internal" href="../LanguageGuide/ControlFlow.html#ID129"><span class="std std-ref">Switch</span></a> section of the <a class="reference internal" href="../LanguageGuide/ControlFlow.html"><span class="doc">Control Flow</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Statements.html#ID436"><span class="std std-ref">Switch Statement</span></a> section of the <a class="reference internal" href="../ReferenceManual/Statements.html"><span class="doc">Statements</span></a> chapter.</li>
<li>Updated the discussion of function types in the <a class="reference internal" href="../ReferenceManual/Types.html#ID449"><span class="std std-ref">Function Type</span></a> section now that function argument labels are no longer part of a function’s type.</li>
<li>Updated the discussion of protocol composition types in the <a class="reference internal" href="../LanguageGuide/Protocols.html#ID282"><span class="std std-ref">Protocol Composition</span></a> section of the <a class="reference internal" href="../LanguageGuide/Protocols.html"><span class="doc">Protocols</span></a> chapter and in the <a class="reference internal" href="../ReferenceManual/Types.html#ID454"><span class="std std-ref">Protocol Composition Type</span></a> section of the <a class="reference internal" href="../ReferenceManual/Types.html"><span class="doc">Types</span></a> chapter to use the new <code class="docutils literal"><span class="pre">Protocol1</span> <span class="pre">&amp;</span> <span class="pre">Protocol2</span></code> syntax.</li>
<li>Updated the discussion in the Dynamic Type Expression section to use the new <code class="docutils literal"><span class="pre">type(of:)</span></code> syntax for dynamic type expressions.</li>
<li>Updated the discussion of line control statements to use the <code class="docutils literal"><span class="pre">#sourceLocation(file:line:)</span></code> syntax in the <a class="reference internal" href="../ReferenceManual/Statements.html#ID540"><span class="std std-ref">Line Control Statement</span></a> section.</li>
<li>Updated the discussion in <a class="reference internal" href="../ReferenceManual/Declarations.html#ID551"><span class="std std-ref">Functions that Never Return</span></a> to use the new <code class="docutils literal"><span class="pre">Never</span></code> type.</li>
<li>Added information about playground literals to the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID390"><span class="std std-ref">Literal Expression</span></a> section.</li>
<li>Updated the discussion in the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID545"><span class="std std-ref">In-Out Parameters</span></a> section to note that only nonescaping closures can capture in-out parameters.</li>
<li>Updated the discussion about default parameters in the <a class="reference internal" href="../LanguageGuide/Functions.html#ID169"><span class="std std-ref">Default Parameter Values</span></a> section, now that they can’t be reordered in function calls.</li>
<li>Updated attribute arguments to use a colon in the <a class="reference internal" href="../ReferenceManual/Attributes.html"><span class="doc">Attributes</span></a> chapter.</li>
<li>Added information about throwing an error inside the catch block of a rethrowing function to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID531"><span class="std std-ref">Rethrowing Functions and Methods</span></a> section.</li>
<li>Added information about accessing the selector of an Objective-C property’s getter or setter to the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID547"><span class="std std-ref">Selector Expression</span></a> section.</li>
<li>Added information to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID361"><span class="std std-ref">Type Alias Declaration</span></a> section about generic type aliases and using type aliases inside of protocols.</li>
<li>Updated the discussion of function types in the <a class="reference internal" href="../ReferenceManual/Types.html#ID449"><span class="std std-ref">Function Type</span></a> section to note that parentheses around the parameter types are required.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Attributes.html"><span class="doc">Attributes</span></a> chapter to note that the <code class="docutils literal"><span class="pre">&#64;IBAction</span></code>, <code class="docutils literal"><span class="pre">&#64;IBOutlet</span></code>, and <code class="docutils literal"><span class="pre">&#64;NSManaged</span></code> attributes imply the <code class="docutils literal"><span class="pre">&#64;objc</span></code> attribute.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">&#64;GKInspectable</span></code> attribute to the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section.</li>
<li>Updated the discussion of optional protocol requirements in the <a class="reference internal" href="../LanguageGuide/Protocols.html#ID284"><span class="std std-ref">Optional Protocol Requirements</span></a> section to clarify that they are used only in code that interoperates with Objective-C.</li>
<li>Removed the discussion of explicitly using <code class="docutils literal"><span class="pre">let</span></code> in function parameters from the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID362"><span class="std std-ref">Function Declaration</span></a> section.</li>
<li>Removed the discussion of the <code class="docutils literal"><span class="pre">Boolean</span></code> protocol from the <a class="reference internal" href="../ReferenceManual/Statements.html"><span class="doc">Statements</span></a> chapter, now that the protocol has been removed from the Swift standard library.</li>
<li>Corrected the discussion of the <code class="docutils literal"><span class="pre">&#64;NSApplicationMain</span></code> attribute in the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section.</li>
</ul>
<p><strong>2016-03-21</strong></p>
<ul class="simple">
<li>Updated for Swift 2.2.</li>
<li>Added information about how to conditionally compile code depending on the version of Swift being used to the <a class="reference internal" href="../ReferenceManual/Statements.html#ID539"><span class="std std-ref">Conditional Compilation Block</span></a> section.</li>
<li>Added information about how to distinguish between methods or initializers whose names differ only by the names of their arguments to the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID400"><span class="std std-ref">Explicit Member Expression</span></a> section.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">#selector</span></code> syntax for Objective-C selectors to the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID547"><span class="std std-ref">Selector Expression</span></a> section.</li>
<li>Updated the discussion of associated types to use the <code class="docutils literal"><span class="pre">associatedtype</span></code> keyword in the <a class="reference internal" href="../LanguageGuide/Generics.html#ID189"><span class="std std-ref">Associated Types</span></a> and <a class="reference internal" href="../ReferenceManual/Declarations.html#ID374"><span class="std std-ref">Protocol Associated Type Declaration</span></a> sections.</li>
<li>Updated information about initializers that return <code class="docutils literal"><span class="pre">nil</span></code> before the instance is fully initialized in the <a class="reference internal" href="../LanguageGuide/Initialization.html#ID224"><span class="std std-ref">Failable Initializers</span></a> section.</li>
<li>Added information about comparing tuples to the <a class="reference internal" href="../LanguageGuide/BasicOperators.html#ID70"><span class="std std-ref">Comparison Operators</span></a> section.</li>
<li>Added information about using keywords as external parameter names to the <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID413"><span class="std std-ref">Keywords and Punctuation</span></a> section.</li>
<li>Updated the discussion of the <code class="docutils literal"><span class="pre">&#64;objc</span></code> attribute in the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section to note that enumerations and enumeration cases can use this attribute.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID418"><span class="std std-ref">Operators</span></a> section with discussion of custom operators that contain a dot.</li>
<li>Added a note to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID531"><span class="std std-ref">Rethrowing Functions and Methods</span></a> section that rethrowing functions can’t directly throw errors.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/Properties.html#ID262"><span class="std std-ref">Property Observers</span></a> section about property observers being called when you pass a property as an in-out parameter.</li>
<li>Added a section about error handling to the <a class="reference internal" href="../GuidedTour/GuidedTour.html"><span class="doc">A Swift Tour</span></a> chapter.</li>
<li>Updated figures in the <a class="reference internal" href="../LanguageGuide/AutomaticReferenceCounting.html#ID53"><span class="std std-ref">Weak References</span></a> section to show the deallocation process more clearly.</li>
<li>Removed discussion of C-style <code class="docutils literal"><span class="pre">for</span></code> loops, the <code class="docutils literal"><span class="pre">++</span></code> prefix and postfix operators, and the <code class="docutils literal"><span class="pre">--</span></code> prefix and postfix operators.</li>
<li>Removed discussion of variable function arguments and the special syntax for curried functions.</li>
</ul>
<p><strong>2015-10-20</strong></p>
<ul class="simple">
<li>Updated for Swift 2.1.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID292"><span class="std std-ref">String Interpolation</span></a> and <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID417"><span class="std std-ref">String Literals</span></a> sections now that string interpolations can contain string literals.</li>
<li>Added the <a class="reference internal" href="../LanguageGuide/Closures.html#ID546"><span class="std std-ref">Escaping Closures</span></a> section with information about the <code class="docutils literal"><span class="pre">&#64;noescape</span></code> attribute.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> and <a class="reference internal" href="../ReferenceManual/Statements.html#ID539"><span class="std std-ref">Conditional Compilation Block</span></a> sections with information about tvOS.</li>
<li>Added information about the behavior of in-out parameters to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID545"><span class="std std-ref">In-Out Parameters</span></a> section.</li>
<li>Added information to the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID544"><span class="std std-ref">Capture Lists</span></a> section about how values specified in closure capture lists are captured.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/OptionalChaining.html#ID248"><span class="std std-ref">Accessing Properties Through Optional Chaining</span></a> section to clarify how assignment through optional chaining behaves.</li>
<li>Improved the discussion of autoclosures in the <a class="reference internal" href="../LanguageGuide/Closures.html#ID543"><span class="std std-ref">Autoclosures</span></a> section.</li>
<li>Added an example that uses the <code class="docutils literal"><span class="pre">??</span></code> operator to the <a class="reference internal" href="../GuidedTour/GuidedTour.html"><span class="doc">A Swift Tour</span></a> chapter.</li>
</ul>
<p><strong>2015-09-16</strong></p>
<ul class="simple">
<li>Updated for Swift 2.0.</li>
<li>Added information about error handling to the <a class="reference internal" href="../LanguageGuide/ErrorHandling.html"><span class="doc">Error Handling</span></a> chapter, the <a class="reference internal" href="../ReferenceManual/Statements.html#ID533"><span class="std std-ref">Do Statement</span></a> section, the <a class="reference internal" href="../ReferenceManual/Statements.html#ID518"><span class="std std-ref">Throw Statement</span></a> section, the <a class="reference internal" href="../ReferenceManual/Statements.html#ID532"><span class="std std-ref">Defer Statement</span></a> section, and the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID516"><span class="std std-ref">Try Operator</span></a> section.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/ErrorHandling.html#ID509"><span class="std std-ref">Representing and Throwing Errors</span></a> section, now that all types can conform to the <code class="docutils literal"><span class="pre">ErrorType</span></code> protocol.</li>
<li>Added information about the new <code class="docutils literal"><span class="pre">try?</span></code> keyword to the <a class="reference internal" href="../LanguageGuide/ErrorHandling.html#ID542"><span class="std std-ref">Converting Errors to Optional Values</span></a> section.</li>
<li>Added information about recursive enumerations to the <a class="reference internal" href="../LanguageGuide/Enumerations.html#ID536"><span class="std std-ref">Recursive Enumerations</span></a> section of the <a class="reference internal" href="../LanguageGuide/Enumerations.html"><span class="doc">Enumerations</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID365"><span class="std std-ref">Enumerations with Cases of Any Type</span></a> section of the <a class="reference internal" href="../ReferenceManual/Declarations.html"><span class="doc">Declarations</span></a> chapter.</li>
<li>Added information about API availability checking to the <a class="reference internal" href="../LanguageGuide/ControlFlow.html#ID523"><span class="std std-ref">Checking API Availability</span></a> section of the <a class="reference internal" href="../LanguageGuide/ControlFlow.html"><span class="doc">Control Flow</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Statements.html#ID522"><span class="std std-ref">Availability Condition</span></a> section of the <a class="reference internal" href="../ReferenceManual/Statements.html"><span class="doc">Statements</span></a> chapter.</li>
<li>Added information about the new <code class="docutils literal"><span class="pre">guard</span></code> statement to the <a class="reference internal" href="../LanguageGuide/ControlFlow.html#ID525"><span class="std std-ref">Early Exit</span></a> section of the <a class="reference internal" href="../LanguageGuide/ControlFlow.html"><span class="doc">Control Flow</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Statements.html#ID524"><span class="std std-ref">Guard Statement</span></a> section of the <a class="reference internal" href="../ReferenceManual/Statements.html"><span class="doc">Statements</span></a> chapter.</li>
<li>Added information about protocol extensions to the <a class="reference internal" href="../LanguageGuide/Protocols.html#ID521"><span class="std std-ref">Protocol Extensions</span></a> section of the <a class="reference internal" href="../LanguageGuide/Protocols.html"><span class="doc">Protocols</span></a> chapter.</li>
<li>Added information about access control for unit testing to the <a class="reference internal" href="../LanguageGuide/AccessControl.html#ID519"><span class="std std-ref">Access Levels for Unit Test Targets</span></a> section of the <a class="reference internal" href="../LanguageGuide/AccessControl.html"><span class="doc">Access Control</span></a> chapter.</li>
<li>Added information about the new optional pattern to the <a class="reference internal" href="../ReferenceManual/Patterns.html#ID520"><span class="std std-ref">Optional Pattern</span></a> section of the <a class="reference internal" href="../ReferenceManual/Patterns.html"><span class="doc">Patterns</span></a> chapter.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/ControlFlow.html#ID126"><span class="std std-ref">Repeat-While</span></a> section with information about the <code class="docutils literal"><span class="pre">repeat</span></code>-<code class="docutils literal"><span class="pre">while</span></code> loop.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html"><span class="doc">Strings and Characters</span></a> chapter, now that <code class="docutils literal"><span class="pre">String</span></code> no longer conforms to the <code class="docutils literal"><span class="pre">CollectionType</span></code> protocol from the Swift standard library.</li>
<li>Added information about the new Swift standard library <code class="docutils literal"><span class="pre">print(_:separator:terminator)</span></code> function to the <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID314"><span class="std std-ref">Printing Constants and Variables</span></a> section.</li>
<li>Added information about the behavior of enumeration cases with <code class="docutils literal"><span class="pre">String</span></code> raw values to the <a class="reference internal" href="../LanguageGuide/Enumerations.html#ID535"><span class="std std-ref">Implicitly Assigned Raw Values</span></a> section of the <a class="reference internal" href="../LanguageGuide/Enumerations.html"><span class="doc">Enumerations</span></a> chapter and the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID366"><span class="std std-ref">Enumerations with Cases of a Raw-Value Type</span></a> section of the <a class="reference internal" href="../ReferenceManual/Declarations.html"><span class="doc">Declarations</span></a> chapter.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">&#64;autoclosure</span></code> attribute—including its <code class="docutils literal"><span class="pre">&#64;autoclosure(escaping)</span></code> form—to the <a class="reference internal" href="../LanguageGuide/Closures.html#ID543"><span class="std std-ref">Autoclosures</span></a> section.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section with information about the <code class="docutils literal"><span class="pre">&#64;available</span></code> and <code class="docutils literal"><span class="pre">&#64;warn_unused_result</span></code> attributes.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID350"><span class="std std-ref">Type Attributes</span></a> section with information about the <code class="docutils literal"><span class="pre">&#64;convention</span></code> attribute.</li>
<li>Added an example of using multiple optional bindings with a <code class="docutils literal"><span class="pre">where</span></code> clause to the <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID333"><span class="std std-ref">Optional Binding</span></a> section.</li>
<li>Added information to the <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID417"><span class="std std-ref">String Literals</span></a> section about how concatenating string literals using the <code class="docutils literal"><span class="pre">+</span></code> operator happens at compile time.</li>
<li>Added information to the <a class="reference internal" href="../ReferenceManual/Types.html#ID455"><span class="std std-ref">Metatype Type</span></a> section about comparing metatype values and using them to construct instances with initializer expressions.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID336"><span class="std std-ref">Debugging with Assertions</span></a> section about when user-defined assertions are disabled.</li>
<li>Updated the discussion of the <code class="docutils literal"><span class="pre">&#64;NSManaged</span></code> attribute in the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section, now that the attribute can be applied to certain instance methods.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/Functions.html#ID171"><span class="std std-ref">Variadic Parameters</span></a> section, now that variadic parameters can be declared in any position in a function’s parameter list.</li>
<li>Added information to the <a class="reference internal" href="../LanguageGuide/Initialization.html#ID229"><span class="std std-ref">Overriding a Failable Initializer</span></a> section about how a nonfailable initializer can delegate up to a failable initializer by force-unwrapping the result of the superclass’s initializer.</li>
<li>Added information about using enumeration cases as functions to the <a class="reference internal" href="../ReferenceManual/Declarations.html#ID365"><span class="std std-ref">Enumerations with Cases of Any Type</span></a> section.</li>
<li>Added information about explicitly referencing an initializer to the <a class="reference internal" href="../ReferenceManual/Expressions.html#ID399"><span class="std std-ref">Initializer Expression</span></a> section.</li>
<li>Added information about build configuration and line control statements to the <a class="reference internal" href="../ReferenceManual/Statements.html#ID538"><span class="std std-ref">Compiler Control Statements</span></a> section.</li>
<li>Added a note to the <a class="reference internal" href="../ReferenceManual/Types.html#ID455"><span class="std std-ref">Metatype Type</span></a> section about constructing class instances from metatype values.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/AutomaticReferenceCounting.html#ID53"><span class="std std-ref">Weak References</span></a> section about weak references being unsuitable for caching.</li>
<li>Updated a note in the <a class="reference internal" href="../LanguageGuide/Properties.html#ID264"><span class="std std-ref">Type Properties</span></a> section to mention that stored type properties are lazily initialized.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/Closures.html#ID103"><span class="std std-ref">Capturing Values</span></a> section to clarify how variables and constants are captured in closures.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section to describe when you can apply the <code class="docutils literal"><span class="pre">&#64;objc</span></code> attribute to classes.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/ErrorHandling.html#ID512"><span class="std std-ref">Handling Errors</span></a> section about the performance of executing a <code class="docutils literal"><span class="pre">throw</span></code> statement. Added similar information about the <code class="docutils literal"><span class="pre">do</span></code> statement in the <a class="reference internal" href="../ReferenceManual/Statements.html#ID533"><span class="std std-ref">Do Statement</span></a> section.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/Properties.html#ID264"><span class="std std-ref">Type Properties</span></a> section with information about stored and computed type properties for classes, structures, and enumerations.</li>
<li>Updated the <a class="reference internal" href="../ReferenceManual/Statements.html#ID441"><span class="std std-ref">Break Statement</span></a> section with information about labeled break statements.</li>
<li>Updated a note in the <a class="reference internal" href="../LanguageGuide/Properties.html#ID262"><span class="std std-ref">Property Observers</span></a> section to clarify the behavior of <code class="docutils literal"><span class="pre">willSet</span></code> and <code class="docutils literal"><span class="pre">didSet</span></code> observers.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/AccessControl.html#ID5"><span class="std std-ref">Access Levels</span></a> section with information about the scope of <code class="docutils literal"><span class="pre">private</span></code> access.</li>
<li>Added a note to the <a class="reference internal" href="../LanguageGuide/AutomaticReferenceCounting.html#ID53"><span class="std std-ref">Weak References</span></a> section about the differences in weak references between garbage collected systems and ARC.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID295"><span class="std std-ref">Special Characters in String Literals</span></a> section with a more precise definition of Unicode scalars.</li>
</ul>
<p><strong>2015-04-08</strong></p>
<ul class="simple">
<li>Updated for Swift 1.2.</li>
<li>Swift now has a native <code class="docutils literal"><span class="pre">Set</span></code> collection type. For more information, see <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID484"><span class="std std-ref">Sets</span></a>.</li>
<li><code class="docutils literal"><span class="pre">&#64;autoclosure</span></code> is now an attribute of the parameter declaration, not its type. There is also a new <code class="docutils literal"><span class="pre">&#64;noescape</span></code> parameter declaration attribute. For more information, see <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a>.</li>
<li>Type methods and properties now use the <code class="docutils literal"><span class="pre">static</span></code> keyword as a declaration modifier. For more information see <a class="reference internal" href="../ReferenceManual/Declarations.html#ID483"><span class="std std-ref">Type Variable Properties</span></a>.</li>
<li>Swift now includes the <code class="docutils literal"><span class="pre">as?</span></code> and <code class="docutils literal"><span class="pre">as!</span></code> failable downcast operators. For more information, see <a class="reference internal" href="../LanguageGuide/Protocols.html#ID283"><span class="std std-ref">Checking for Protocol Conformance</span></a>.</li>
<li>Added a new guide section about <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID534"><span class="std std-ref">String Indices</span></a>.</li>
<li>Removed the overflow division (<code class="docutils literal"><span class="pre">&amp;/</span></code>) and overflow remainder (<code class="docutils literal"><span class="pre">&amp;%</span></code>) operators from <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID37"><span class="std std-ref">Overflow Operators</span></a>.</li>
<li>Updated the rules for constant and constant property declaration and initialization. For more information, see <a class="reference internal" href="../ReferenceManual/Declarations.html#ID355"><span class="std std-ref">Constant Declaration</span></a>.</li>
<li>Updated the definition of Unicode scalars in string literals. See <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID295"><span class="std std-ref">Special Characters in String Literals</span></a>.</li>
<li>Updated <a class="reference internal" href="../LanguageGuide/BasicOperators.html#ID73"><span class="std std-ref">Range Operators</span></a> to note that a half-open range with the same start and end index will be empty.</li>
<li>Updated <a class="reference internal" href="../LanguageGuide/Closures.html#ID104"><span class="std std-ref">Closures Are Reference Types</span></a> to clarify the capturing rules for variables.</li>
<li>Updated <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID38"><span class="std std-ref">Value Overflow</span></a> to clarify the overflow behavior of signed and unsigned integers</li>
<li>Updated <a class="reference internal" href="../ReferenceManual/Declarations.html#ID369"><span class="std std-ref">Protocol Declaration</span></a> to clarify protocol declaration scope and members.</li>
<li>Updated <a class="reference internal" href="../LanguageGuide/AutomaticReferenceCounting.html#ID58"><span class="std std-ref">Defining a Capture List</span></a> to clarify the syntax for weak and unowned references in closure capture lists.</li>
<li>Updated <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID418"><span class="std std-ref">Operators</span></a> to explicitly mention examples of supported characters for custom operators, such as those in the Mathematical Operators, Miscellaneous Symbols, and Dingbats Unicode blocks.</li>
<li>Constants can now be declared without being initialized in local function scope. They must have a set value before first use. For more information, see <a class="reference internal" href="../ReferenceManual/Declarations.html#ID355"><span class="std std-ref">Constant Declaration</span></a>.</li>
<li>In an initializer, constant properties can now only assign a value once. For more information, see <a class="reference internal" href="../LanguageGuide/Initialization.html#ID212"><span class="std std-ref">Assigning Constant Properties During Initialization</span></a>.</li>
<li>Multiple optional bindings can now appear in a single <code class="docutils literal"><span class="pre">if</span></code> statement as a comma-separated list of assignment expressions. For more information, see <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID333"><span class="std std-ref">Optional Binding</span></a>.</li>
<li>An <a class="reference internal" href="../ReferenceManual/Expressions.html#ID405"><span class="std std-ref">Optional-Chaining Expression</span></a> must appear within a postfix expression.</li>
<li>Protocol casts are no longer limited to <code class="docutils literal"><span class="pre">&#64;objc</span></code> protocols.</li>
<li>Type casts that can fail at runtime now use the <code class="docutils literal"><span class="pre">as?</span></code> or <code class="docutils literal"><span class="pre">as!</span></code> operator, and type casts that are guaranteed not to fail use the <code class="docutils literal"><span class="pre">as</span></code> operator. For more information, see <a class="reference internal" href="../ReferenceManual/Expressions.html#ID388"><span class="std std-ref">Type-Casting Operators</span></a>.</li>
</ul>
<p><strong>2014-10-16</strong></p>
<ul class="simple">
<li>Updated for Swift 1.1.</li>
<li>Added a full guide to <a class="reference internal" href="../LanguageGuide/Initialization.html#ID224"><span class="std std-ref">Failable Initializers</span></a>.</li>
<li>Added a description of <a class="reference internal" href="../LanguageGuide/Protocols.html#ID274"><span class="std std-ref">Failable Initializer Requirements</span></a> for protocols.</li>
<li>Constants and variables of type <code class="docutils literal"><span class="pre">Any</span></code> can now contain function instances. Updated the example in <a class="reference internal" href="../LanguageGuide/TypeCasting.html#ID342"><span class="std std-ref">Type Casting for Any and AnyObject</span></a> to show how to check for and cast to a function type within a <code class="docutils literal"><span class="pre">switch</span></code> statement.</li>
<li>Enumerations with raw values now have a <code class="docutils literal"><span class="pre">rawValue</span></code> property rather than a <code class="docutils literal"><span class="pre">toRaw()</span></code> method and a failable initializer with a <code class="docutils literal"><span class="pre">rawValue</span></code> parameter rather than a <code class="docutils literal"><span class="pre">fromRaw()</span></code> method. For more information, see <a class="reference internal" href="../LanguageGuide/Enumerations.html#ID149"><span class="std std-ref">Raw Values</span></a> and <a class="reference internal" href="../ReferenceManual/Declarations.html#ID366"><span class="std std-ref">Enumerations with Cases of a Raw-Value Type</span></a>.</li>
<li>Added a new reference section about <a class="reference internal" href="../ReferenceManual/Declarations.html#ID376"><span class="std std-ref">Failable Initializers</span></a>, which can trigger initialization failure.</li>
<li>Custom operators can now contain the <code class="docutils literal"><span class="pre">?</span></code> character. Updated the <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID418"><span class="std std-ref">Operators</span></a> reference to describe the revised rules. Removed a duplicate description of the valid set of operator characters from <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID46"><span class="std std-ref">Custom Operators</span></a>.</li>
</ul>
<p><strong>2014-08-18</strong></p>
<ul class="simple">
<li>New document that describes Swift 1.0, Apple’s new programming language for building iOS and OS X apps.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/Protocols.html#ID272"><span class="std std-ref">Initializer Requirements</span></a> in protocols.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/Protocols.html#ID281"><span class="std std-ref">Class-Only Protocols</span></a>.</li>
<li><a class="reference internal" href="../LanguageGuide/TheBasics.html#ID335"><span class="std std-ref">Assertions and Preconditions</span></a> can now use string interpolation. Removed a note to the contrary.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID291"><span class="std std-ref">Concatenating Strings and Characters</span></a> section to reflect the fact that <code class="docutils literal"><span class="pre">String</span></code> and <code class="docutils literal"><span class="pre">Character</span></code> values can no longer be combined with the addition operator (<code class="docutils literal"><span class="pre">+</span></code>) or addition assignment operator (<code class="docutils literal"><span class="pre">+=</span></code>). These operators are now used only with <code class="docutils literal"><span class="pre">String</span></code> values. Use the <code class="docutils literal"><span class="pre">String</span></code> type’s <code class="docutils literal"><span class="pre">append(_:)</span></code> method to append a single <code class="docutils literal"><span class="pre">Character</span></code> value onto the end of a string.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">availability</span></code> attribute to the <a class="reference internal" href="../ReferenceManual/Attributes.html#ID348"><span class="std std-ref">Declaration Attributes</span></a> section.</li>
<li><a class="reference internal" href="../LanguageGuide/TheBasics.html#ID330"><span class="std std-ref">Optionals</span></a> no longer implicitly evaluate to <code class="docutils literal"><span class="pre">true</span></code> when they have a value and <code class="docutils literal"><span class="pre">false</span></code> when they do not, to avoid confusion when working with optional <code class="docutils literal"><span class="pre">Bool</span></code> values. Instead, make an explicit check against <code class="docutils literal"><span class="pre">nil</span></code> with the <code class="docutils literal"><span class="pre">==</span></code> or <code class="docutils literal"><span class="pre">!=</span></code> operators to find out if an optional contains a value.</li>
<li>Swift now has a <a class="reference internal" href="../LanguageGuide/BasicOperators.html#ID72"><span class="std std-ref">Nil-Coalescing Operator</span></a> (<code class="docutils literal"><span class="pre">a</span> <span class="pre">??</span> <span class="pre">b</span></code>), which unwraps an optional’s value if it exists, or returns a default value if the optional is <code class="docutils literal"><span class="pre">nil</span></code>.</li>
<li>Updated and expanded the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID298"><span class="std std-ref">Comparing Strings</span></a> section to reflect and demonstrate that string and character comparison and prefix / suffix comparison are now based on Unicode canonical equivalence of extended grapheme clusters.</li>
<li>You can now try to set a property’s value, assign to a subscript, or call a mutating method or operator through <a class="reference internal" href="../LanguageGuide/OptionalChaining.html"><span class="doc">Optional Chaining</span></a>. The information about <a class="reference internal" href="../LanguageGuide/OptionalChaining.html#ID248"><span class="std std-ref">Accessing Properties Through Optional Chaining</span></a> has been updated accordingly, and the examples of checking for method call success in <a class="reference internal" href="../LanguageGuide/OptionalChaining.html#ID249"><span class="std std-ref">Calling Methods Through Optional Chaining</span></a> have been expanded to show how to check for property setting success.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/OptionalChaining.html#ID251"><span class="std std-ref">Accessing Subscripts of Optional Type</span></a> through optional chaining.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID110"><span class="std std-ref">Accessing and Modifying an Array</span></a> section to note that you can no longer append a single item to an array with the <code class="docutils literal"><span class="pre">+=</span></code> operator. Instead, use the <code class="docutils literal"><span class="pre">append(_:)</span></code> method, or append a single-item array with the <code class="docutils literal"><span class="pre">+=</span></code> operator.</li>
<li>Added a note that the start value <code class="docutils literal"><span class="pre">a</span></code> for the <a class="reference internal" href="../LanguageGuide/BasicOperators.html#ID73"><span class="std std-ref">Range Operators</span></a> <code class="docutils literal"><span class="pre">a...b</span></code> and <code class="docutils literal"><span class="pre">a..&lt;b</span></code> must not be greater than the end value <code class="docutils literal"><span class="pre">b</span></code>.</li>
<li>Rewrote the <a class="reference internal" href="../LanguageGuide/Inheritance.html"><span class="doc">Inheritance</span></a> chapter to remove its introductory coverage of initializer overrides. This chapter now focuses more on the addition of new functionality in a subclass, and the modification of existing functionality with overrides. The chapter’s example of <a class="reference internal" href="../LanguageGuide/Inheritance.html#ID200"><span class="std std-ref">Overriding Property Getters and Setters</span></a> has been rewritten to show how to override a <code class="docutils literal"><span class="pre">description</span></code> property. (The examples of modifying an inherited property’s default value in a subclass initializer have been moved to the <a class="reference internal" href="../LanguageGuide/Initialization.html"><span class="doc">Initialization</span></a> chapter.)</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/Initialization.html#ID221"><span class="std std-ref">Initializer Inheritance and Overriding</span></a> section to note that overrides of a designated initializer must now be marked with the <code class="docutils literal"><span class="pre">override</span></code> modifier.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/Initialization.html#ID231"><span class="std std-ref">Required Initializers</span></a> section to note that the <code class="docutils literal"><span class="pre">required</span></code> modifier is now written before every subclass implementation of a required initializer, and that the requirements for required initializers can now be satisfied by automatically inherited initializers.</li>
<li>Infix <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID42"><span class="std std-ref">Operator Methods</span></a> no longer require the <code class="docutils literal"><span class="pre">&#64;infix</span></code> attribute.</li>
<li>The <code class="docutils literal"><span class="pre">&#64;prefix</span></code> and <code class="docutils literal"><span class="pre">&#64;postfix</span></code> attributes for <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID43"><span class="std std-ref">Prefix and Postfix Operators</span></a> have been replaced by <code class="docutils literal"><span class="pre">prefix</span></code> and <code class="docutils literal"><span class="pre">postfix</span></code> declaration modifiers.</li>
<li>Added a note about the order in which <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID43"><span class="std std-ref">Prefix and Postfix Operators</span></a> are applied when both a prefix and a postfix operator are applied to the same operand.</li>
<li>Operator functions for <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID44"><span class="std std-ref">Compound Assignment Operators</span></a> no longer use the <code class="docutils literal"><span class="pre">&#64;assignment</span></code> attribute when defining the function.</li>
<li>The order in which modifiers are specified when defining <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID46"><span class="std std-ref">Custom Operators</span></a> has changed. You now write <code class="docutils literal"><span class="pre">prefix</span> <span class="pre">operator</span></code> rather than <code class="docutils literal"><span class="pre">operator</span> <span class="pre">prefix</span></code>, for example.</li>
<li>Added information about the <code class="docutils literal"><span class="pre">dynamic</span></code> declaration modifier in <a class="reference internal" href="../ReferenceManual/Declarations.html#ID381"><span class="std std-ref">Declaration Modifiers</span></a>.</li>
<li>Added information about how type inference works with <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID414"><span class="std std-ref">Literals</span></a>.</li>
<li>Added more information about curried functions.</li>
<li>Added a new chapter about <a class="reference internal" href="../LanguageGuide/AccessControl.html"><span class="doc">Access Control</span></a>.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html"><span class="doc">Strings and Characters</span></a> chapter to reflect the fact that Swift’s <code class="docutils literal"><span class="pre">Character</span></code> type now represents a single Unicode extended grapheme cluster. Includes a new section on <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID296"><span class="std std-ref">Extended Grapheme Clusters</span></a> and more information about <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID294"><span class="std std-ref">Unicode Scalars</span></a> and <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID298"><span class="std std-ref">Comparing Strings</span></a>.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html#ID286"><span class="std std-ref">String Literals</span></a> section to note that Unicode scalars inside string literals are now written as <code class="docutils literal"><span class="pre">\u{n}</span></code>, where <code class="docutils literal"><span class="pre">n</span></code> is a hexadecimal number between 0 and 10FFFF, the range of Unicode’s codespace.</li>
<li>The <code class="docutils literal"><span class="pre">NSString</span></code> <code class="docutils literal"><span class="pre">length</span></code> property is now mapped onto Swift’s native <code class="docutils literal"><span class="pre">String</span></code> type as <code class="docutils literal"><span class="pre">utf16Count</span></code>, not <code class="docutils literal"><span class="pre">utf16count</span></code>.</li>
<li>Swift’s native <code class="docutils literal"><span class="pre">String</span></code> type no longer has an <code class="docutils literal"><span class="pre">uppercaseString</span></code> or <code class="docutils literal"><span class="pre">lowercaseString</span></code> property. The corresponding section in <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html"><span class="doc">Strings and Characters</span></a> has been removed, and various code examples have been updated.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/Initialization.html#ID210"><span class="std std-ref">Initializer Parameters Without Argument Labels</span></a>.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/Initialization.html#ID231"><span class="std std-ref">Required Initializers</span></a>.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/Functions.html#ID165"><span class="std std-ref">Optional Tuple Return Types</span></a>.</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID312"><span class="std std-ref">Type Annotations</span></a> section to note that multiple related variables can be defined on a single line with one type annotation.</li>
<li>The <code class="docutils literal"><span class="pre">&#64;optional</span></code>, <code class="docutils literal"><span class="pre">&#64;lazy</span></code>, <code class="docutils literal"><span class="pre">&#64;final</span></code>, and <code class="docutils literal"><span class="pre">&#64;required</span></code> attributes are now the <code class="docutils literal"><span class="pre">optional</span></code>, <code class="docutils literal"><span class="pre">lazy</span></code>, <code class="docutils literal"><span class="pre">final</span></code>, and <code class="docutils literal"><span class="pre">required</span></code> <a class="reference internal" href="../ReferenceManual/Declarations.html#ID381"><span class="std std-ref">Declaration Modifiers</span></a>.</li>
<li>Updated the entire book to refer to <code class="docutils literal"><span class="pre">..&lt;</span></code> as the <a class="reference internal" href="../LanguageGuide/BasicOperators.html#ID75"><span class="std std-ref">Half-Open Range Operator</span></a> (rather than the “half-closed range operator”).</li>
<li>Updated the <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID116"><span class="std std-ref">Accessing and Modifying a Dictionary</span></a> section to note that <code class="docutils literal"><span class="pre">Dictionary</span></code> now has a Boolean <code class="docutils literal"><span class="pre">isEmpty</span></code> property.</li>
<li>Clarified the full list of characters that can be used when defining <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID46"><span class="std std-ref">Custom Operators</span></a>.</li>
<li><code class="docutils literal"><span class="pre">nil</span></code> and the Booleans <code class="docutils literal"><span class="pre">true</span></code> and <code class="docutils literal"><span class="pre">false</span></code> are now <a class="reference internal" href="../ReferenceManual/LexicalStructure.html#ID414"><span class="std std-ref">Literals</span></a>.</li>
<li>Swift’s <code class="docutils literal"><span class="pre">Array</span></code> type now has full value semantics. Updated the information about <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID106"><span class="std std-ref">Mutability of Collections</span></a> and <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID107"><span class="std std-ref">Arrays</span></a> to reflect the new approach. Also clarified the assignment and copy behavior for strings arrays and dictionaries.</li>
<li><a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID108"><span class="std std-ref">Array Type Shorthand Syntax</span></a> is now written as <code class="docutils literal"><span class="pre">[SomeType]</span></code> rather than <code class="docutils literal"><span class="pre">SomeType[]</span></code>.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID114"><span class="std std-ref">Dictionary Type Shorthand Syntax</span></a>, which is written as <code class="docutils literal"><span class="pre">[KeyType:</span> <span class="pre">ValueType]</span></code>.</li>
<li>Added a new section about <a class="reference internal" href="../LanguageGuide/CollectionTypes.html#ID493"><span class="std std-ref">Hash Values for Set Types</span></a>.</li>
<li>Examples of <a class="reference internal" href="../LanguageGuide/Closures.html#ID95"><span class="std std-ref">Closure Expressions</span></a> now use the global <code class="docutils literal"><span class="pre">sorted(_:_:)</span></code> function rather than the global <code class="docutils literal"><span class="pre">sort(_:_:)</span></code> function, to reflect the new array value semantics.</li>
<li>Updated the information about <a class="reference internal" href="../LanguageGuide/Initialization.html#ID214"><span class="std std-ref">Memberwise Initializers for Structure Types</span></a> to clarify that the memberwise structure initializer is made available even if a structure’s stored properties do not have default values.</li>
<li>Updated to <code class="docutils literal"><span class="pre">..&lt;</span></code> rather than <code class="docutils literal"><span class="pre">..</span></code> for the <a class="reference internal" href="../LanguageGuide/BasicOperators.html#ID75"><span class="std std-ref">Half-Open Range Operator</span></a>.</li>
<li>Added an example of <a class="reference internal" href="../LanguageGuide/Generics.html#ID185"><span class="std std-ref">Extending a Generic Type</span></a>.</li>
</ul>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="../ReferenceManual/zzSummaryOfTheGrammar.html">Summary of the Grammar</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
